#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var line_reader_1 = require("line-reader");
var replace_in_file_1 = require("replace-in-file");
var yargs_1 = require("yargs");
var fs_1 = require("fs");
var glob_1 = require("glob");
var lineByLine = require('n-readlines');
var cdFunctionName = "__changeDectector__()";
var cdCallCounter = "\tprivate __changeDetectorCounter__ = 0";
var cdHtmlTag = "<label id=\"__changeDetector__\" hidden>{{ " + cdFunctionName + " }}</label>";
var ChangeDetector = /** @class */ (function () {
    function ChangeDetector(modules, components, verbose) {
        this._verbose = false;
        this._workingComponents = [];
        this._appModules = modules;
        this._appComponents = components;
        this._verbose = verbose;
    }
    Object.defineProperty(ChangeDetector.prototype, "verbose", {
        get: function () {
            return this._verbose;
        },
        enumerable: false,
        configurable: true
    });
    ChangeDetector.prototype.addModule = function (module) {
        var _a;
        var modules = typeof module === 'string' ? [module] : module;
        for (var _i = 0, modules_1 = modules; _i < modules_1.length; _i++) {
            var moduleName = modules_1[_i];
            try {
                var moduleInfo = this.findAppFile(moduleName, "module");
                var moduleComponents = this.extractComponentsFromModule(moduleInfo);
                (_a = this._workingComponents).push.apply(_a, moduleComponents);
            }
            catch (error) {
                console.error(error);
            }
        }
    };
    ChangeDetector.prototype.addComponent = function (component) {
        var components = typeof component === 'string' ? [component] : component;
        for (var _i = 0, components_1 = components; _i < components_1.length; _i++) {
            var componentName = components_1[_i];
            try {
                var componentInfo = this.findAppFile(componentName, "component");
                this._workingComponents.push(componentInfo);
            }
            catch (error) {
                console.error(error);
            }
        }
    };
    ChangeDetector.prototype.extractComponentsFromModule = function (moduleInfo) {
        var lineReader = new lineByLine(moduleInfo.fullPath);
        var lineObj;
        var line;
        var components = [];
        if (this.verbose)
            console.log("\nFinding components imported by " + moduleInfo.basename + ":");
        while (lineObj = lineReader.next()) {
            line = lineObj.toString('ascii');
            if (line.includes("import") && line.includes("from") && line.includes(".component")) {
                var imprtArr = line.split('/');
                var componentName = "" + imprtArr[imprtArr.length - 1].replace(".component", "").replace(/[^a-zA-Z\-\.]/g, "");
                var componentInfo = this.findAppFile(componentName, "component");
                if (this.verbose)
                    console.log(" *", componentInfo.basename.replace(".ts", ""));
                components.push(componentInfo);
            }
        }
        return components;
    };
    ChangeDetector.prototype.findAppFile = function (name, fileType) {
        var file = fileType === "module"
            ? this._appModules.find(function (module) { return module.includes(name + ".module.ts"); })
            : this._appComponents.find(function (component) { return component.includes(name + ".component.ts"); });
        if (!file) {
            throw new Error("File " + name + "." + fileType + ".ts not found");
        }
        return file ? { fullPath: file, basename: this.basename(file) } : undefined;
    };
    ChangeDetector.prototype.addCodeToComponents = function () {
        var _this = this;
        this.removeDuplicateComponentsInList();
        if (this._workingComponents.length > 0)
            console.log("\nAdding change detector code to:");
        this._workingComponents.forEach(function (file) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.addCode(file.fullPath, file.basename);
                return [2 /*return*/];
            });
        }); });
    };
    ChangeDetector.prototype.cleanComponents = function () {
        var _this = this;
        this.removeDuplicateComponentsInList();
        console.log("\nRemoving change detector code from:");
        this._workingComponents.forEach(function (file) {
            console.log(" -", file.basename.replace(".ts", ""));
            _this.clean(file.fullPath);
        });
    };
    ChangeDetector.prototype.addCode = function (tsFullPath, basename) {
        var _this = this;
        var componetName = basename.replace(".ts", "");
        fs_1.readFile(tsFullPath, function (err, data) {
            if (err)
                throw err;
            if (!data.includes("__changeDectector")) {
                console.log(" -", componetName);
                var htmlFullPath = tsFullPath.replace(".ts", ".html");
                _this.addCodeToHtmlFile(htmlFullPath);
                _this.addCodeToTSFile(tsFullPath, basename);
            }
            else {
                console.log(" -", componetName, "(skipped)");
                if (_this.verbose)
                    console.log("   Skipping " + componetName + ": already contains change detector code\n");
            }
        });
    };
    ChangeDetector.prototype.clean = function (tsFullPath) {
        var htmlFullPath = tsFullPath.replace(".ts", ".html");
        this.cleanHtmlFile(htmlFullPath);
        this.cleanTSFile(tsFullPath);
    };
    ChangeDetector.prototype.addCodeToHtmlFile = function (fullPath) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs_1.appendFile(fullPath, "" + cdHtmlTag, function (err) {
                            if (err)
                                throw err;
                        })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ChangeDetector.prototype.addCodeToTSFile = function (fullPath, basename) {
        var _this = this;
        var original = "";
        var origWithChanges = "";
        var startKey = "export class";
        var componentName = this.toTitleCase(basename.split(".")[0]);
        line_reader_1.eachLine(fullPath, function (line) {
            if (line.includes(startKey) || original) {
                original += line + "\n";
                origWithChanges += origWithChanges ? line + "\n" : line + "\n" + cdCallCounter + "\n";
                if (_this.isBalanced(original)) {
                    origWithChanges = origWithChanges.replace(/\}\n$/, _this.generateCDFunction(componentName) + "\n}\n");
                    _this.findAndReplace(fullPath, original, origWithChanges);
                    return false;
                }
            }
        });
    };
    ChangeDetector.prototype.cleanHtmlFile = function (fullPath) {
        var original = "";
        var cleaned = "";
        var lineObj;
        var line;
        var lineReader = new lineByLine(fullPath);
        while (lineObj = lineReader.next()) {
            line = lineObj.toString('ascii');
            original += line + "\n";
            cleaned += line.includes(cdHtmlTag) ? line.replace(cdHtmlTag, "") : line + "\n";
        }
        fs_1.writeFile(fullPath, cleaned, 'utf8', function (err) {
            if (err)
                return console.log(err);
        });
    };
    ChangeDetector.prototype.cleanTSFile = function (fullPath) {
        var original = "";
        var cleaned = "";
        var tmp_fn = "";
        var keyFound = false;
        var keyInLine = false;
        var lineReader = new lineByLine(fullPath);
        var lineObj;
        var line;
        while (lineObj = lineReader.next()) {
            line = lineObj.toString('ascii');
            original += line + "\n";
            keyInLine = line.includes(cdFunctionName);
            if (keyInLine) {
                keyFound = true;
            }
            if (!line.includes(cdCallCounter) && !keyFound && !keyInLine) {
                cleaned += line + "\n";
            }
            else {
                if (keyFound || keyInLine) {
                    tmp_fn += line + "\n";
                    if (this.isBalanced(tmp_fn)) {
                        this.findAndReplace(fullPath, original, cleaned);
                        break;
                    }
                }
            }
        }
    };
    ChangeDetector.prototype.toTitleCase = function (str) {
        return str.charAt(0).toUpperCase() + str.slice(1);
    };
    ChangeDetector.prototype.isBalanced = function (str) {
        return Array.from(str).reduce(function (uptoPrevChar, thisChar) {
            ((thisChar === '{' && uptoPrevChar++ || thisChar === '}' && uptoPrevChar--));
            return uptoPrevChar;
        }, 0) === 0;
    };
    ChangeDetector.prototype.findAndReplace = function (filename, findStr, changeTo) {
        return __awaiter(this, void 0, void 0, function () {
            var options, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = {
                            files: filename,
                            from: findStr,
                            to: changeTo,
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, replace_in_file_1.replaceInFile(options)];
                    case 2:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        console.error('Error occurred:', error_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ChangeDetector.prototype.generateCDFunction = function (name) {
        return "\t" + cdFunctionName + " {\n\t\tconsole.log(\"%c[ " + name + " component ] Change detection called\", 'font-weight: bold;', this.__changeDetectorCounter__)\n\t\tthis.__changeDetectorCounter__++\n\t}";
    };
    ChangeDetector.prototype.removeDuplicateComponentsInList = function () {
        var _this = this;
        this._workingComponents = this._workingComponents.filter(function (e, i) { return _this._workingComponents.findIndex(function (a) { return a.basename === e.basename; }) === i; });
    };
    ChangeDetector.prototype.basename = function (fullPath) {
        var arr = fullPath.split("/");
        return arr[arr.length - 1];
    };
    return ChangeDetector;
}());
var options = yargs_1.usage("Usage: $0 -p <path> [options]")
    .option("p", { alias: "path", describe: "Path to root directory of Angular project", type: "string", demandOption: true })
    .option("m", { alias: "module", describe: "Feature module to apply to", type: "string", demandOption: false })
    .option("c", { alias: "component", describe: "Component to apply to", type: "string", demandOption: false })
    .option("undo", { describe: "Remove changes added by Change Detector", type: "boolean", demandOption: false })
    .option("v", { alias: "verbose", describe: "Output any logging", type: "boolean", demandOption: false })
    .example('$0 -p ~/my-app -c home', 'Apply on component')
    .example('$0 -p ~/my-app -m dashboard', 'Apply on module')
    .example('$0 -p ~/my-app -c home -c navbar -m dashboard', 'Apply on mulitple components/modules')
    .example('$0 -p ~/my-app -c home -m dashboard --undo', 'Remove injected code from components')
    .argv;
var path = options.path;
fs_1.access(path + "/angular.json", function (err) { return __awaiter(void 0, void 0, void 0, function () {
    var appModules, appComponents, changeDetector;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!!!err) return [3 /*break*/, 1];
                console.log("Not an Angular Directory");
                return [2 /*return*/];
            case 1:
                appModules = glob_1.sync(path + "/src/**/*module.ts", { realpath: true });
                appComponents = glob_1.sync(path + "/src/**/*component.ts", { realpath: true });
                if (!options.module && !options.component) {
                    console.log("\nPlease specify a component (-c) or feature module (-m)\n");
                    return [2 /*return*/];
                }
                changeDetector = new ChangeDetector(appModules, appComponents, !!options.verbose);
                if (!options.module) return [3 /*break*/, 3];
                return [4 /*yield*/, changeDetector.addModule(options.module)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                if (!options.component) return [3 /*break*/, 5];
                return [4 /*yield*/, changeDetector.addComponent(options.component)];
            case 4:
                _a.sent();
                _a.label = 5;
            case 5:
                if (options.undo) {
                    changeDetector.cleanComponents();
                }
                else {
                    changeDetector.addCodeToComponents();
                }
                _a.label = 6;
            case 6: return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=index.js.map